

local levels = {
  {
    {30, "chaff_extra", 6},
    {15, "chaff_extra", 6},
    {5, "chaff_extra", 6},
    {10, "chaff_extra", 6},
  },
  {
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {15, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
    {2, "chaff_extra", 6},
  },
  {
    {5, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {10, "tank", 6},
    {30, "chaff_extra", 6},
  },
  {
    {15, "chaff_extra", 6},
    {15, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "chaff_extra", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
    {0, "bomb", 6},
  },
  {
    {0, "tank", 6},
    {10, "bomb", 6},
    {5, "bomb", 6},
    {10, "tank", 6},
    {0, "tank", 6},
    {15, "bomb", 6},
  }
}

local tick

local function moveup(lev)
  local overlay = CreateFrame("Frame")
  overlay:SetLayer(2)
  overlay:SetAllPoints()
  overlay:SetBackgroundColor(0, 0, 0, 0.5)
  
  local tex = CreateFrame("Text", overlay)
  tex:SetText("ENTERING STAGE " .. lev)
  tex:SetSize(60)
  tex:SetColor(1, 1, 1)
  tex:SetPoint("CENTER", UIParent, "CENTER")
  
  coroutine.pause(120)
  
  overlay:Detach()
end

local process = coroutine.wrap(function ()
  local geer
  local lev = 1
  while true do
    local cl = runuifile("level.lua", levels[lev], geer)
    
    tick = function (...) cl.tick_loop(...) end
    
    while not cl.level_complete and not cl.level_failed do
      coroutine.yield()
    end
    
    if cl.level_complete then
      geer = cl.level_complete
      lev = lev + 1
      
      if lev > #levels then
        local overlay = CreateFrame("Frame")
        overlay:SetLayer(2)
        overlay:SetAllPoints()
        overlay:SetBackgroundColor(0, 0, 0, 0.5)

        local tex = CreateFrame("Text", overlay)
        tex:SetText("VICTORY!")
        tex:SetSize(60)
        tex:SetColor(1, 1, 1)
        tex:SetPoint("CENTER", UIParent, "CENTER")
        
        local tex = CreateFrame("Text", overlay)
        tex:SetText("You have succeeded with " .. geer.lives .. " lives left!")
        tex:SetSize(30)
        tex:SetColor(1, 1, 1)
        tex:SetPoint("CENTER", UIParent, "CENTER", 0, 50)
        coroutine.pause(120)
        
        while not WasKeyPressed("mouse_left") and not WasKeyPressed("w") and not WasKeyPressed("a") and not WasKeyPressed("s") and not WasKeyPressed("d") and not WasKeyPressed("space") do
          coroutine.yield()
        end

        GlorpController("exit_game")
        
        while true do
          coroutine.yield()
        end
      else
        moveup(lev)
      end
    else
      local overlay = CreateFrame("Frame")
      overlay:SetLayer(2)
      overlay:SetAllPoints()
      overlay:SetBackgroundColor(0, 0, 0, 0.5)

      local tex = CreateFrame("Text", overlay)
      tex:SetText("YOU HAVE FAILED")
      tex:SetSize(60)
      tex:SetColor(1, 1, 1)
      tex:SetPoint("CENTER", UIParent, "CENTER")
      
      local tex = CreateFrame("Text", overlay)
      tex:SetText("Catastrophe at level " .. lev)
      tex:SetSize(30)
      tex:SetColor(1, 1, 1)
      tex:SetPoint("CENTER", UIParent, "CENTER", 0, 50)
      coroutine.pause(120)
      
      while not WasKeyPressed("mouse_left") and not WasKeyPressed("w") and not WasKeyPressed("a") and not WasKeyPressed("s") and not WasKeyPressed("d") and not WasKeyPressed("space") do
        coroutine.yield()
      end

      GlorpController("exit_game")
    end
      
    cl.UIRoot:Detach()
  end
end)


function tick_loop(...)
  process()
  if tick then tick() end
end
