
ShowMouseCursor(true)
ShowMouseCursorInMenu(true)

local tutors = {}

local poosh

do
  local function make_tutor_world()
    local but = CreateFrame("Button")
    
    function but:Click()
      poosh()
    end
    
    table.insert(tutors, but)
    
    but:Hide()
    
    local tabi = CreateFrame("Frame", but)
    tabi:SetAllPoints(UIParent)
    
    return but
  end
  
  local function liney(base, tex, align, x, y)
    local t = CreateFrame("Text", base)
    t:SetLayer(5)
    t:SetText(tex)
    t:SetColor(1, 1, 1)
    if type(align) == "table" then
      t:SetPoint(align[1], align[2], UIParent, "CENTER", x, y)
    else
      t:SetPoint(align, UIParent, "CENTER", x, y)
    end
    return t
  end
  
  do
    local t = make_tutor_world()
    local tex = CreateFrame("Texture", t)
    
    tex:SetTexture("tutor_1")
    tex:SetPoint("CENTER", UIParent, "CENTER", 0, -200)
    
    liney(t, "Use WASD to move.", "CENTER", 0, 0)
    liney(t, "Do not move into evil robots!", "CENTER", 0, 50)
    liney(t, "They are not your friends.", "CENTER", 0, 100)
  end
  
  do
    local t = make_tutor_world()
    local tex = CreateFrame("Texture", t)
    
    tex:SetTexture("tutor_2")
    tex:SetPoint("CENTER", UIParent, "CENTER", -200, 0)
    
    liney(t, "Left-click to shoot things.", {0, 0.5}, 80, -50)
    liney(t, "Shooting things:", {0, 0.5}, 80, 0)
    liney(t, "Totally awesome.", {0, 0.5}, 80, 50)
  end
  
  do
    local t = make_tutor_world()
    local tex = CreateFrame("Texture", t)
    
    tex:SetTexture("tutor_3")
    tex:SetPoint("CENTER", UIParent, "CENTER", 0, 200)
    
    liney(t, "Right-click on monsters to suck them up and use them as part of your weapon.", "CENTER", 0, -200):SetSize(30)
    liney(t, "THIS IS IMPORTANT.", "CENTER", 0, -100)
  end
  
  do
    local t = make_tutor_world()
    local tex = CreateFrame("Texture", t)
    
    tex:SetTexture("tutor_4")
    tex:SetPoint("CENTER", UIParent, "CENTER", 200, 0)
    
    liney(t, "Some monsters will tell you what they'll become.", {0, 0.5}, -500, -250)
    liney(t, "Some monsters are a surprise!", {0, 0.5}, -500, -200)
    liney(t, "You like surprises, don't you?", {0, 0.5}, -500, -150)
    liney(t, "Everyone likes surprises.", {0, 0.5}, -500, -100)
    liney(t, "Different parts will make your gun work differently!", {0, 0.5}, -500, 100)
    liney(t, "Sometimes that might be useful.", {0, 0.5}, -500, 150)
    liney(t, "Sometimes it won't!", {0, 0.5}, -500, 200)
    liney(t, "It's an adventure!", {0, 0.5}, -500, 250)
  end
  
  do
    local t = make_tutor_world()
    local tex = CreateFrame("Texture", t)
    
    tex:SetTexture("tutor_5")
    tex:SetPoint("CENTER", UIParent, "CENTER", 0, -200)
    
    liney(t, "Your weapon will fall apart as you use it,", "CENTER", 0, 100)
    liney(t, "so keep sucking those monsters!", "CENTER", 0, 130)
    liney(t, "SUCK THEM LIKE YOUR LIFE DEPENDS ON IT.", "CENTER", 0, 200)
  end
end

local bg = CreateFrame("Texture", menu)
bg:SetTexture("splash")
bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT")

local chassis = CreateFrame("Text", bg)
chassis:SetText("CHASSIS")
chassis:SetColor(1, 1, 1)
chassis:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", -2400, -250)
chassis:SetSize(180)
do
  local cx_s = -2400
  local cx_e = 50
  local cx_d = 30
  function chassis:Tick()
    cx_s = math.min(cx_s + cx_d, cx_e)
    chassis:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", cx_s, -250)
  end
end

local commander = CreateFrame("Text", bg)
commander:SetText("COMMANDER")
commander:SetColor(1, 1, 1)
commander:SetPoint("TOPRIGHT", UIParent, "BOTTOMRIGHT", 3500, -180)
commander:SetSize(180)
commander:SetLayer(1)

do
  local cx_s = 3500
  local cx_e = -50
  local cx_d = -30
  function commander:Tick()
    cx_s = math.max(cx_s + cx_d, cx_e)
    commander:SetPoint("TOPRIGHT", UIParent, "BOTTOMRIGHT", cx_s, -180)
  end
end


disable_anchor()
pause_on_nofocus = true

menu.ok_text:SetPoint("CENTER", UIParent, "CENTER", 0, 70)
menu.ok_text:SetText("START!")
menu.ok_button:SetLayer(5)

local tutor = CreateFrame("Button", menu)
local ttx = CreateFrame("Text", tutor)
ttx:SetText("INSTRUCTIONS! (seriously you want to read this)")
ttx:SetColor(1, 0.9, 0.9)
ttx:SetPoint("TOPLEFT", menu.ok_text, "BOTTOMLEFT")
ttx:SetSize(30)

menu.exit_text:SetPoint("CENTER", UIParent, "CENTER", 0, 250)
menu.exit_button:Hide()

local tutpos = nil
local showtut

function showtut()
  menu:Hide()
  for _, v in ipairs(tutors) do
    v:Hide()
  end
  
  if tutpos > #tutors then
    menu:Show()
  else
    tutors[tutpos]:Show()
  end
  
  poosh = function()
    tutpos = tutpos + 1
    showtut()
  end
end
function tutor:Click()
  tutpos = 1
  showtut()
end

function tick_loop()
  ShowMouseCursor(true)
end